=== modified file 'NEWS'
--- NEWS	2005-09-12 01:29:49 +0000
+++ NEWS	2005-09-12 09:47:33 +0000
@@ -21,6 +21,9 @@
     * Fixed strange error when trying to access a nonexistent http
       branch.
 
+    * Make sure that the hashcache gets written out if it can't be
+      read.
+
 
   PORTABILITY:
 

=== modified file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2005-07-22 18:49:46 +0000
+++ bzrlib/hashcache.py	2005-09-12 09:47:33 +0000
@@ -222,6 +222,8 @@
             inf = file(fn, 'rb', buffering=65000)
         except IOError, e:
             mutter("failed to open %s: %s" % (fn, e))
+            # better write it now so it is valid
+            self.needs_write = True
             return
 
 
@@ -229,6 +231,7 @@
         if hdr != CACHE_HEADER:
             mutter('cache header marker not found at top of %s; discarding cache'
                    % fn)
+            self.needs_write = True
             return
 
         for l in inf:

